Bug 1413959 - [RFE] Need a way to resolve gfid split brains
Summary: [RFE] Need a way to resolve gfid split brains
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: replicate
Version: rhgs-3.2
Hardware: Unspecified
OS: Unspecified
high
medium
Target Milestone: ---
: RHGS 3.4.0
Assignee: Karthik U S
QA Contact: Vijay Avuthu
URL:
Whiteboard: rebase
Depends On: 1459530
Blocks: 1503132 1531934
TreeView+ depends on / blocked
 
Reported: 2017-01-17 12:44 UTC by nchilaka
Modified: 2018-09-19 06:34 UTC (History)
8 users (show)

Fixed In Version: glusterfs-3.12.2-1
Doc Type: Enhancement
Doc Text:
WIth this release, GFID split-brains can be resolved from the CLI using any of the policies: choice of brick, mtime or size. You need to provide the absolute path of the file which needs GFID heal.
Clone Of:
: 1459530 1531934 (view as bug list)
Environment:
Last Closed: 2018-09-04 06:29:55 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:2607 None None None 2018-09-04 06:32:05 UTC

Description nchilaka 2017-01-17 12:44:46 UTC
Description of problem:
=====================
Currently there is no way for the admin from CLI to resolve gfid split brain based on some policy like choice of the brick, mtime or size or a way to retain both files
The only option is for the admin to work on the files from backend ie bricks
We should be having a way to resolve gfid split brain




Version-Release number of selected component (if applicable):
============
3.8.4-11

Comment 5 Karthik U S 2017-08-24 11:15:06 UTC
Upstream patch: https://review.gluster.org/#/c/17485/

Comment 8 Vijay Avuthu 2018-03-13 12:29:13 UTC
Update
=========

Verified with below scenario's

scenario 1:

1) created gfid split-brain 
2) resolved split-brain using "bigger-file" option
3) wait for heal to complete


scenario 2:

1) created gfid split-brain 
2) resolved split-brain using "mtime" option
3) wait for heal to complete


scenario 3:

1) created gfid split-brain 
2) resolved split-brain using "source-brick" option
3) wait for heal to complete

Observation:

After issuing split-brain command using policy, observed healing is not done immediately. Its taking few minutes to complete healing ( even with single file ) but from back end its clearing the dirty tag immediately.

Comment 9 Karthik U S 2018-03-13 12:50:28 UTC
Once you run this command it will immediately resolve the gfid split-brain but there might be some data heal pending on the entry after this. So you can see the entry in the heal info output until that is cleared by explicitly running the heal or by doing any update operations on the file or the shd kicks in at the regular interval.
Once the heal completes the entry will be removed from the heal info.

Comment 10 Vijay Avuthu 2018-03-13 13:27:37 UTC
Changing status to Verified.

See #comment 8 for more details.

Comment 11 Srijita Mukherjee 2018-09-03 15:35:21 UTC
Have updated the doc text. Kindly review and confirm.

Comment 12 Karthik U S 2018-09-03 16:04:46 UTC
LGTM.

Comment 13 errata-xmlrpc 2018-09-04 06:29:55 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:2607


Note You need to log in before you can comment on or make changes to this bug.